/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import com.rjconsultores.ventaboletos.entidad.MotivoCancelacion;
import com.rjconsultores.ventaboletos.service.MotivoCancelacionService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import java.util.Calendar;
import java.util.List;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;

/**
 * 
 * @author Rafius
 */
@Controller("editarMotivoCancelacionController")
@Scope("prototype")
public class EditarMotivoCancelacionController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;

	@Autowired
	private MotivoCancelacionService motivoCancelacionService;
	private MotivoCancelacion motivoCancelacion;
	private MyListbox motivoCancelacionList;
	private static Logger log = Logger.getLogger(EditarMotivoCancelacionController.class);
	private Textbox txtNome;
	private Button btnApagar;
	private Combobox cmbTipoMotivo;

	public Button getBtnApagar() {
		return btnApagar;
	}

	public void setBtnApagar(Button btnApagar) {
		this.btnApagar = btnApagar;
	}

	public Textbox getTxtNome() {
		return txtNome;
	}

	public void setTxtNome(Textbox txtNome) {
		this.txtNome = txtNome;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		motivoCancelacion = (MotivoCancelacion) Executions.getCurrent().getArg().get("motivoCancelacion");
		motivoCancelacionList = (MyListbox) Executions.getCurrent().getArg().get("motivoCancelacionList");

		if (motivoCancelacion.getMotivocancelacionId() == null) {
			btnApagar.setVisible(Boolean.FALSE);
		} else {
			if (motivoCancelacionService.validaMotivoCancelacionConstante(motivoCancelacion)) {
				btnApagar.setVisible(false);
				txtNome.setDisabled(true);

				Messagebox.show(
						Labels.getLabel("MSG.noEditabled"),
						Labels.getLabel("editarMotivoCancelacionController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			}
		}

		txtNome.focus();
	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		txtNome.getValue();
		cmbTipoMotivo.getValue();
		try {
			motivoCancelacion.setActivo(true);
			motivoCancelacion.setFecmodif(Calendar.getInstance().getTime());
			motivoCancelacion.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
			if (motivoCancelacion.getTipomotivo() == null) {
				Messagebox.show(
						Labels.getLabel("editarMotivoCancelacionController.MSG.tipo"),
						Labels.getLabel("editarMotivoCancelacionController.window.title"),
						Messagebox.OK, Messagebox.EXCLAMATION);
			} else {
				if (motivoCancelacion.getMotivocancelacionId() == null) {
					List<MotivoCancelacion> lsMotivoCancelacion =
							motivoCancelacionService.buscar(motivoCancelacion.getDescmotivo(),
									motivoCancelacion.getTipomotivo());

					if (lsMotivoCancelacion.isEmpty()) {
						motivoCancelacionService.suscribir(motivoCancelacion);
						motivoCancelacionList.addItem(motivoCancelacion);

						Messagebox.show(
								Labels.getLabel("editarMotivoCancelacionController.MSG.suscribirOK"),
								Labels.getLabel("editarMotivoCancelacionController.window.title"),
								Messagebox.OK, Messagebox.INFORMATION);
					} else {
						Messagebox.show(
								Labels.getLabel("MSG.Registro.Existe"),
								Labels.getLabel("editarMotivoCancelacionController.window.title"),
								Messagebox.OK, Messagebox.EXCLAMATION);
					}
				} else {
					motivoCancelacionService.actualizacion(motivoCancelacion);
					motivoCancelacionList.updateItem(motivoCancelacion);

					Messagebox.show(
							Labels.getLabel("editarMotivoCancelacionController.MSG.suscribirOK"),
							Labels.getLabel("editarMotivoCancelacionController.window.title"),
							Messagebox.OK, Messagebox.INFORMATION);
				}

				closeWindow();
			}
		} catch (Exception ex) {
			log.error("editarMotivoCancelacionController: " + ex);
			Messagebox.show(
					Labels.getLabel("MSG.Error"),
					Labels.getLabel("editarMotivoCancelacionController.window.title"),
					Messagebox.OK, Messagebox.ERROR);
		}
	}

	public void onClick$btnApagar(Event ev) {
		try {
			int resp = Messagebox.show(
					Labels.getLabel("editarMotivoCancelacionController.MSG.borrarPergunta"),
					Labels.getLabel("editarMotivoCancelacionController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {

				motivoCancelacionService.borrar(motivoCancelacion);

				Messagebox.show(
						Labels.getLabel("editarMotivoCancelacionController.MSG.borrarOK"),
						Labels.getLabel("editarMotivoCancelacionController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				motivoCancelacionList.removeItem(motivoCancelacion);

				closeWindow();
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public MotivoCancelacion getMotivoCancelacion() {
		return motivoCancelacion;
	}

	public void setMotivoCancelacion(MotivoCancelacion motivoCancelacion) {
		this.motivoCancelacion = motivoCancelacion;
	}

	public MyListbox getMotivoCancelacionList() {
		return motivoCancelacionList;
	}

	public void setMotivoCancelacionList(MyListbox motivoCancelacionList) {
		this.motivoCancelacionList = motivoCancelacionList;
	}

	public MotivoCancelacionService getMotivoCancelacionService() {
		return motivoCancelacionService;
	}

	public void setMotivoCancelacionService(MotivoCancelacionService motivoCancelacionService) {
		this.motivoCancelacionService = motivoCancelacionService;
	}
}
